
//http://lazplanet.blogspot.ch/2013/05/a-simple-image-viewer-from-start-to.html
 //http://wiki.lazarus.freepascal.org/Developing_with_Graphics#Painting_on_the_bitmap_of_a_TImage
// Modified M.Weber 03.01.2017


unit frm1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Buttons, StdCtrls, ComCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnOpen: TBitBtn;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    edtRTop: TEdit;
    edtRLeft: TEdit;
    edtRRight: TEdit;
    edtRBottom: TEdit;
    edtYFactor: TEdit;
    edtXFactor: TEdit;
    edtXSize: TEdit;
    edtYSize: TEdit;
    edtZoom: TEdit;
    edtImageWidth: TEdit;
    edtImageHeight: TEdit;
    Image1: TImage;
    Image2: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    lblXSize: TLabel;
    lblYSize: TLabel;
    Label7: TLabel;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    ScrollBox1: TScrollBox;
    ScrollBox2: TScrollBox;
    trkXSize: TTrackBar;
    trkYSize: TTrackBar;
    TrkZoom: TTrackBar;
    procedure btnOpenClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Image2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

    procedure trkXSizeChange(Sender: TObject);
    procedure trkYSizeChange(Sender: TObject);

    procedure TrkZoomChange(Sender: TObject);

    Procedure Calculation;
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

  i, r: TRect;
  x, y, xx, yy: integer;
  zoom : integer;
  xPos,YPos : Integer;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  form1.top := 150;
  form1.left := 150;
  form1.width := 1400;
  form1.height := 750;


  y := 0;
  x :=  0;
  xx := Image2.Width;
  yy := Image2.Height;
  r.Top := y; r.Left := x; r.Right := xx; r.Bottom := yy;
  i.Top := 0;
  i.Left := 0;
  i.Right := Image1.Width;
  i.Bottom := Image1.Height;
  //Image2.Canvas.CopyRect(r, Image1.Picture.Bitmap.Canvas, i);

  XPos := 50;
  YPos := 50;

  zoom :=  TrkZoom.Position;
  edtZoom.Caption := IntToStr(TrkZoom.position);

  Calculation;
end;

procedure TForm1.Image2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  case Button of
   //mbRight: Form1.Memo1.Lines.Add('Right Mouse: '+IntToStr(x)+' '+IntToStr(y));
   mbLeft: Form1.Memo1.Lines.Add('Left Mouse  XPos : '+IntToStr(x)+' YPos : '+IntToStr(y));
   //mbMiddle: Form1.Memo1.Lines.Add('Middle Mouse: '+IntToStr(x)+' '+IntToStr(y));
  end;
end;

Procedure tform1.Calculation;
begin
  r.Top := trunc(y * YPos / zoom);
  r.Left := trunc(x * XPos /zoom);
  r.Right := trunc(xx * XPos /zoom);
  r.Bottom := trunc(yy * YPos /zoom);

  edtImageWidth.caption := IntToStr(Image1.Width);
  edtImageHeight.caption := IntToStr(Image1.Height);

  edtRTop.caption := IntToStr(r.Top);
  edtRLeft.caption := IntToStr(r.Left);
  edtRRight.caption := IntToStr(r.Right);
  edtRBottom.caption := IntToStr(r.Bottom);

  edtXSize.Caption := IntToStr(XPos);
  edtYSize.Caption := IntToStr(YPos);
  edtZoom.Caption := IntToStr(Zoom);

  edtXFactor.caption := FormatFloat('###,###0.000',XPos/zoom*100);
  edtYFactor.caption := FormatFloat('###,###0.000',YPos/zoom*100);

  Image2.Canvas.Clear;
  Image2.Canvas.CopyRect(r, Image1.Picture.Bitmap.Canvas, i);
end;

procedure TForm1.btnOpenClick(Sender: TObject);
Var
x,y : integer;
Bmp: TBitmap;
//Png: TPNGObject;
begin
  OpenDialog1.Execute;
  if (OpenDialog1.Files.Count = 1) and (FileExistsUTF8(OpenDialog1.FileName)) then
  begin
    Image1.Picture.LoadFromFile(OpenDialog1.FileName);
  end;
  Calculation;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  //draws just a rectangle for test

  with Image1.picture do
  begin
    Image1.Picture.bitmap.Canvas.Brush.Color:=clyellow;
    Image1.Picture.bitmap.Canvas.Rectangle(150,50,300,150);
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Image2.width := Image1.Width;
  Calculation;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Image2.width := R.Right;
end;

procedure TForm1.trkXSizeChange(Sender: TObject);
begin
  XPos := trkXSize.Position;
  Calculation;
end;

procedure TForm1.trkYSizeChange(Sender: TObject);
begin
 YPos := trkYSize.Position;
 Calculation;
end;

procedure TForm1.TrkZoomChange(Sender: TObject);
begin
  zoom :=  101-TrkZoom.Position;   //better not get zero
  calculation;
end;


end.

